"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const Generator = require("yeoman-generator");
const branch_finder_1 = require("./branch-finder");
class BaseGenerator extends Generator {
    _copyOp(srcPath, tgtPath, transFns) {
        const copyOptions = {};
        if (transFns && transFns.length) {
            copyOptions.process = (contents) => {
                let s = contents.toString();
                for (const transFn of transFns) {
                    s = transFn(s);
                }
                return s;
            };
        }
        this.fs.copy(srcPath, tgtPath, copyOptions);
    }
    _branchCopy(opt) {
        const source = opt.source;
        const tgtBase = opt.target || "";
        const transformers = opt.transformers || [];
        const pattern = opt.pattern || "**/*";
        const branches = opt.branches || {};
        const srcBase = this.sourceRoot();
        const options = {
            pattern: path.join(source, pattern),
            tgtRelalative: source,
            branches,
            transformers,
            op: this._copyOp.bind(this),
        };
        const bf = new branch_finder_1.default(srcBase, tgtBase, options);
        bf.run();
    }
}
exports.default = BaseGenerator;
